#!/bin/bash

usage() {
    cat <<EOF
Usage: $0 <path>

where <path> is a file or a directory.

EOF
    exit 1
}

# evaluate the status of a file
test_file() {
    local file=$1

    if [[ ! -e $file ]]; then
        echo "$file does not exist"
        return 1
    else
        # test using the command 'test'
        if test -f $file ; then
            echo "$file is a regular file."
        fi

        # test using [...]
        if [ -d $file ]; then
            echo "$file is a directory."
        fi

        # test using [[...]]
        if [[ -r $file ]]; then
            echo "$file is readable."
        fi

        [[ -w $file ]] && echo "$file is writable."

        [[ ! -x $file ]] \
            || echo "$file is executable/searchable."
    fi
}

# [[ -z $1 ]] && usage
[[ -n $1 ]] || usage

# call the function
test_file $1
